#include "drawutilities.h"

#include <QPainter>
#include <QStyleOptionGraphicsItem>
#include <QWidget>
#include <QBrush>
#include <QPen>

#include <Box2D/Box2D.h>

#include "mathutility.h"

void genericPaint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget, b2Body *body)
{
    QBrush b(Qt::red);
    QPen p(Qt::black);
    p.setWidthF(0.1f);
    painter->setPen(p);

    b2Fixture* fixture = body->GetFixtureList();
    while(fixture != NULL)
    {
        if(fixture->GetDensity() >= 0)
            genericPaintFixture(painter, option, widget, fixture);

        fixture = fixture->GetNext();
    }
}

void genericPaintFixture(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget, b2Fixture *fixture)
{
    widget;
    option;
    QPen pen(Qt::black);
    pen.setWidthF(0.1f);
    painter->setPen(pen);

    b2Shape* shape = fixture->GetShape();
    b2CircleShape* c;
    b2PolygonShape* p;
    switch(shape->GetType())
    {
    case b2Shape::e_circle:
        c = (b2CircleShape*)shape;
        painter->drawEllipse(QPointF(c->m_p.x, c->m_p.y), c->m_radius, c->m_radius);
        break;

    case b2Shape::e_polygon:
        p = (b2PolygonShape*)shape;
        QPointF* points = new QPointF[p->m_vertexCount];
        b2Vec2ToQPointF(p->m_vertices, p->m_vertexCount, points);
        painter->drawPolygon(points, p->m_vertexCount);
        delete[] points;
        break;
    }
}
