#ifndef CONTROLLERSERVER_H
#define CONTROLLERSERVER_H

#include <QObject>
#include <QUdpSocket>

/*!
 * \brief The ControllerServer class listens to a UDP socket for messages, then forwards them to the correct controller.
 */
class ControllerServer : public QObject
{
    Q_OBJECT
public:
    explicit ControllerServer(QObject *parent = 0, quint16 port = 37875);
    ~ControllerServer();
    
signals:
    
public slots:
    /*!
     * \brief starts the server and makes it listen to the specified port.
     */
    void start();

private slots:
    /*!
     * \brief incomingConnection is called when a new message is ready to be handled.
     */
    void incomingConnection();
private:
    QUdpSocket* _server;
    quint16 _port;
};

#endif // CONTROLLERSERVER_H
