#ifndef DRAWUTILITIES_H
#define DRAWUTILITIES_H

class b2Body;
class b2Fixture;
class QPainter;
class QStyleOptionGraphicsItem;
class QWidget;

/*!
 * \brief genericPaint draws all fixtures on a body, handling the simple cases where all you want to draw is the physical boundaries.
 * \param body is the body containing the fixtures to draw.
 */
void genericPaint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget, b2Body* body);

/*!
 * \brief genericPaintFixture draws a single fixture.
 * \param fixture is the fixture to draw the boundaries of.
 */
void genericPaintFixture(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget, b2Fixture *fixture);

#endif // DRAWUTILITIES_H
