#ifndef JSONHELPERS_H
#define JSONHELPERS_H

#include <QPointF>
#include <QJsonObject>

/*!
 * \brief Converts a JSON object containing the attributes "x" and "y" to a QPointF object.
 * \param obj JSON object with "x" and "y" attributes.
 * \return QPointF containing the x and y coordinates given by obj.
 */
QPointF jsonObjectToPoint(const QJsonObject &obj);

#endif // JSONHELPERS_H
