#include "physicalobjectfactory.h"

#include "PhysicalObjects/arena.h"
#include "PhysicalObjects/chirp.h"
#include "PhysicalObjects/physicalobject.h"
#include "PhysicalObjects/pushableobject.h"
#include "PhysicalObjects/wall.h"

PhysicalObjectFactory *PhysicalObjectFactory::_instance = NULL;

PhysicalObjectFactory::PhysicalObjectFactory() :
    QObject(0), _map()
{
    addFactory("arena", arenaFactory);
    addFactory("chirp", chirpFactory);
    addFactory("pushableobject", pushableObjectFactory);
    addFactory("wall", wallFactory);
}

PhysicalObjectFactory *PhysicalObjectFactory::instance()
{
    if(_instance == NULL)
        _instance = new PhysicalObjectFactory();

    return _instance;
}


void PhysicalObjectFactory::addFactory(const QString &name, FactoryFunction factoryFunction)
{
    _map[name.toLower()] = factoryFunction;
}

FactoryFunction *PhysicalObjectFactory::getFactory(const QString &name)
{
    return _map[name.toLower()];
}
