#include "robotrepository.h"

#include "robot.h"

RobotRepository* RobotRepository::_instance = NULL;

RobotRepository::RobotRepository() :
    _map()
{
}


RobotRepository *RobotRepository::instance()
{
    if(_instance == NULL)
        _instance = new RobotRepository();

    return _instance;
}

void RobotRepository::addRobot(Robot *robot)
{
    _map[robot->id()] = robot;
}

Robot *RobotRepository::getRobotFromId(quint32 id)
{
    QMap<quint32, Robot*>::iterator it = _map.find(id);
    if(it == _map.end())
        return NULL;
    return *it;
}
